/*
-------------------------------------------------------------------------------
                                I   M   L   I   B
				       1.1
-------------------------------------------------------------------------------

This software is Copyright (C) 1998 By The Rasterman (Carsten Haitzler). I
accept no responsability for anythign this software may or may not do to
your system - you use it completely at your own risk. This software comes
under the LGPL and GPL licences. The library itself is LGPL (all software in
Imlib and gdk_imlib directories) see the COPYING and COPYING.LIB files for
full legal details.
*/

#include "gdk_imlib.h"
#include "gdk_imlib_private.h"

void _PaletteAlloc(int num, int *cols)
{
   XColor xcl;
   int i;
   int r,g,b;
   
   for(i=0;i<num;i++)
     {
	r=cols[(i*3)+0];
	g=cols[(i*3)+1];
	b=cols[(i*3)+2];
	xcl.red=(unsigned short)((r<<8)|(r));
	xcl.green=(unsigned short)((g<<8)|(g));
	xcl.blue=(unsigned short)((b<<8)|(b));
	xcl.flags=DoRed|DoGreen|DoBlue;
	XAllocColor(id->x.disp,id->x.root_cmap,&xcl);
	id->palette[i].r=xcl.red>>8;
	id->palette[i].g=xcl.green>>8;
	id->palette[i].b=xcl.blue>>8;
	id->palette[i].pixel=xcl.pixel;
	id->palette_orig[i].r=r;
	id->palette_orig[i].g=g;
	id->palette_orig[i].b=b;
	id->palette_orig[i].pixel=xcl.pixel;
     }
   id->num_colors=num;
}

gint gdk_imlib_load_colors(char *file)
{
   int i;
   int pal[768]={0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xdd, 0xdd, 0xdd,
		0xbb, 0xbb, 0xbb, 0x99, 0x99, 0x99, 0x77, 0x77, 0x77,
		0x55, 0x55, 0x55, 0x33, 0x33, 0x33, 0x88, 0x00, 0x00,
		0xcc, 0x00, 0x00, 0xff, 0x00, 0x00, 0xff, 0x44, 0x00,
    	    	0xff, 0x88, 0x00, 0xff, 0xcc, 0x00, 0xff, 0xff, 0x00,
    	    	0xcc, 0xcc, 0x00, 0x88, 0x88, 0x00, 0x44, 0x44, 0x00,
    	    	0x00, 0x44, 0x00, 0x00, 0x88, 0x00, 0x00, 0xcc, 0x00,
    	    	0x00, 0xff, 0x00, 0x00, 0x44, 0x44, 0x00, 0x88, 0x88,
    	    	0x00, 0xff, 0xff, 0x00, 0x00, 0x44, 0x00, 0x00, 0x88,
    	    	0x00, 0x00, 0xff, 0x88, 0x00, 0x88, 0xff, 0xcc, 0x99,
    	    	0xcc, 0xaa, 0x77, 0xaa, 0x88, 0x55, 0x88, 0x66, 0x33,
    	    	0x66, 0x44, 0x11, 0x44, 0x22, 0x00, 0x22, 0x00, 0x00,
    	    	0x00, 0x44, 0x88, 0x44, 0x88, 0xcc, 0x88, 0xcc, 0xff,
    	    	0x00, 0xcc, 0x44, 0x44, 0x88, 0x44, 0x88, 0xcc, 0x00,
    	    	0x22, 0x44, 0x11, 0x33, 0x66, 0x22, 0x44, 0x55, 0x33,
    	    	0x66, 0x88, 0x44, 0x33, 0x66, 0x22, 0x22, 0x44, 0x11};
   int r,g,b;
   int rr,gg,bb;
   
   i=144;
   _PaletteAlloc((i/3),pal);
   for (r=0;r<32;r++)
     {
	for (g=0;g<32;g++)
	  {
	     for (b=0;b<32;b++)
	       {
		  rr=(r<<3)|(r>>2);
		  gg=(g<<3)|(g>>2);
		  bb=(b<<3)|(b>>2);
		  id->fast_rgb[r][g][b]=gdk_imlib_best_color_match(&rr,&gg,&bb);
		  id->fast_err[r][g][b]=rr;
		  id->fast_erg[r][g][b]=gg;
		  id->fast_erb[r][g][b]=bb;
	       }
	  }
     }
   return 1;
}

void gdk_imlib_free_colors()
{
   int i;
   unsigned long pixels[256];
   
   for (i=0;i<id->num_colors;i++) pixels[i]=id->palette[i].pixel;
   XFreeColors(id->x.disp,id->x.root_cmap,pixels,id->num_colors,0);
   id->num_colors=0;
}
