/******************************************************************************/
/* This software is Copyright (C) 1998 by Rafal Wierzbicki. I accept no       */
/* responsibility for anything this software may or may not do to your system */
/* - you use it completely at your own risk. This software comes under the GPL*/
/* licence. See the COPYING file for full legal details.                      */
/******************************************************************************/


#include <gtk/gtk.h>
#include <gdk/gdkx.h>
#include <gdk_imlib.h>
#define CENTER 1
#define TILE 2
#define SCALE 3

int put_image_on_root (char *imageFile, int STYLE){

   extern ImlibData *id;
   GdkWindow *rootW, *tmpwin;
   GdkGC *rootGC;
   GdkPixmap *rootBack = NULL, *mask, *tmpPix;
   gint rW, rH;
   GdkImlibImage *image;
   char tst[128];
   
   
   image = gdk_imlib_load_image (imageFile);
   if (!image){
      strcpy (tst, "Unknown image format: ");
      strcat (tst, imageFile);
      strcat (tst, "\nremoving from the list");
      error_dialog (tst);
      return -1;
   }

   /* Initialize: visual,colormap etc */
   gtk_widget_push_visual (gdk_imlib_get_visual());
   gtk_widget_push_colormap (gdk_imlib_get_colormap());
   rootW = gdk_window_foreign_new (GDK_ROOT_WINDOW());
   rootGC = gdk_gc_new (rootW);
   gdk_window_get_size (rootW, &rW, &rH);
   
   gdk_imlib_set_render_type(RT_DITHER_TRUECOL);
   
   if (STYLE==CENTER || STYLE==TILE)
     gdk_imlib_render (image, image->width, image->height);
   else
     gdk_imlib_render (image, rW, rH);
   
   rootBack = gdk_imlib_move_image (image);
   mask = gdk_imlib_move_mask (image);
   
   
   /* center */
   if (STYLE==CENTER){ 
      tmpPix = gdk_pixmap_new (rootW, rW, rH, id->x.depth);
      gdk_draw_pixmap (tmpPix, rootGC, rootBack, 0, 0 ,
		       rW/2 - image->width/2,
		       rH/2 - image->height/2, 
		       image->width, image->height);
      gdk_window_set_back_pixmap (rootW, tmpPix, FALSE);
      gdk_pixmap_unref (tmpPix);
   }
   else
     gdk_window_set_back_pixmap (rootW, rootBack, FALSE);
   
   if (mask){
     gdk_window_shape_combine_mask (rootW, mask, 0, 0);
     gdk_pixmap_unref (mask);
   }
   /* Cleanup */
   gdk_pixmap_unref (rootBack);

   gdk_window_clear (rootW);
   gdk_window_unref (rootW);
   gdk_window_destroy (rootW);
   
   gdk_gc_destroy (rootGC);
   
   gdk_imlib_free_pixmap (rootBack);
   gdk_imlib_kill_image (image);
   gdk_flush ();
   return 0;
}
